package com.cmeeting.service;

import com.cmeeting.job.FileProcessTask;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

@Service
@Slf4j
public class FileProcessCallbackHandler {
    
    // 单个任务完成回调
    public void onComplete(FileProcessTask task) {
        // 可以记录任务状态、发送通知等
        log.info("任务处理完成: meetingId {}", task.getMeetingId());
        
        // 更新数据库状态等
        // taskRepository.updateStatus(task.getId(), "COMPLETED");
    }
    
    // 所有任务完成回调
    public void onAllComplete() {
        log.info("所有文件处理任务已完成");
        log.info("任务完成时间: {}", LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")));
        log.info("----------------------------------");
        // 可以发送全局通知等
    }
}