package com.cmeeting.thread.monitor;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ThreadPoolExecutor;

@Service
@Slf4j
public class ThreadPoolMonitorService {

    private final Map<String, ThreadPoolTaskExecutor> executors = new HashMap<>();

    @Autowired
    public ThreadPoolMonitorService(ThreadPoolTaskExecutor fileProcessExecutor) {
        executors.put("fileProcessExecutor", fileProcessExecutor);
    }

    // 获取所有线程池
    public Map<String, ThreadPoolTaskExecutor> getAllExecutors() {
        return executors;
    }

    // 获取指定线程池
    public ThreadPoolTaskExecutor getExecutor(String executorName) {
        return executors.get(executorName);
    }
}
