package com.cmeeting.thread.monitor;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class ThreadPoolStatusInfoSerializer extends StdSerializer<ThreadPoolStatus> {
    private static final Map<String, String> FIELD_MAPPING = new HashMap<>();

    static {
        FIELD_MAPPING.put("poolName", "线程池名称");
        FIELD_MAPPING.put("corePoolSize", "核心线程数");
        FIELD_MAPPING.put("maxPoolSize", "最大线程数");
        FIELD_MAPPING.put("currentPoolSize", "当前线程数");
        FIELD_MAPPING.put("activeThreadCount", "活跃线程数");
        FIELD_MAPPING.put("queueSize", "队列任务数");
        FIELD_MAPPING.put("queueCapacity", "队列容量");
        FIELD_MAPPING.put("totalTasks", "总任务数");
        FIELD_MAPPING.put("completedTasks", "已完成任务数");
        FIELD_MAPPING.put("pendingTasks", "等待任务数");
        FIELD_MAPPING.put("threadUtilization", "线程利用率");
        FIELD_MAPPING.put("queueUtilization", "队列利用率");
        FIELD_MAPPING.put("runningStatus", "运行状态");
        FIELD_MAPPING.put("healthStatus", "健康状态");
    }

    public ThreadPoolStatusInfoSerializer() {
        this(null);
    }

    protected ThreadPoolStatusInfoSerializer(Class<ThreadPoolStatus> t) {
        super(t);
    }

    @Override
    public void serialize(ThreadPoolStatus value, JsonGenerator gen, SerializerProvider provider) throws IOException {
        gen.writeStartObject();

        gen.writeStringField(FIELD_MAPPING.get("poolName"), value.getPoolName());
        gen.writeNumberField(FIELD_MAPPING.get("corePoolSize"), value.getCorePoolSize());
        gen.writeNumberField(FIELD_MAPPING.get("maxPoolSize"), value.getMaxPoolSize());
        gen.writeNumberField(FIELD_MAPPING.get("currentPoolSize"), value.getCurrentPoolSize());
        gen.writeNumberField(FIELD_MAPPING.get("activeThreadCount"), value.getActiveThreadCount());
        gen.writeNumberField(FIELD_MAPPING.get("queueSize"), value.getQueueSize());
        gen.writeNumberField(FIELD_MAPPING.get("queueCapacity"), value.getQueueCapacity());
        gen.writeNumberField(FIELD_MAPPING.get("totalTasks"), value.getTotalTasks());
        gen.writeNumberField(FIELD_MAPPING.get("completedTasks"), value.getCompletedTasks());
        gen.writeNumberField(FIELD_MAPPING.get("pendingTasks"), value.getPendingTasks());
        gen.writeStringField(FIELD_MAPPING.get("threadUtilization"), value.getThreadUtilization());
        gen.writeStringField(FIELD_MAPPING.get("queueUtilization"), value.getQueueUtilization());
        gen.writeStringField(FIELD_MAPPING.get("runningStatus"), value.getRunningStatus());
        gen.writeStringField(FIELD_MAPPING.get("healthStatus"), value.getHealthStatus());

        gen.writeEndObject();
    }
}